unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
* batch 8, API cleanup for exception handling
@ 2020-07-22 10:51 David Bremner
  2020-07-22 10:51 ` [PATCH 01/10] test: move notmuch_message_* tests to their own file David Bremner
                   ` (10 more replies)
  0 siblings, 11 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch

Apparently no changes are needed to notmuch_query_* to handle exceptions from closed databases.

This most likely needs to be applied on top of

     id:20200719131857.158655-1-david@tethera.net

It certainly needs the changes from

   id:20200714224119.717845-1-david@tethera.net, which are not in master yet.

^ permalink raw reply	[flat|nested] 12+ messages in thread

* [PATCH 01/10] test: move notmuch_message_* tests to their own file
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-22 10:51 ` [PATCH 02/10] test: add regression test for n_q_{create,_get_query_string} David Bremner
                   ` (9 subsequent siblings)
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

This is for consistency with the recently added tests for
notmuch_database_*.
---
 test/T560-lib-error.sh   | 359 ------------------------------------
 test/T566-lib-message.sh | 380 +++++++++++++++++++++++++++++++++++++++
 2 files changed, 380 insertions(+), 359 deletions(-)
 create mode 100755 test/T566-lib-message.sh

diff --git a/test/T560-lib-error.sh b/test/T560-lib-error.sh
index 908bb9d8..70df292a 100755
--- a/test/T560-lib-error.sh
+++ b/test/T560-lib-error.sh
@@ -318,363 +318,4 @@ EOF
 test_expect_equal_file EXPECTED OUTPUT.clean
 restore_database
 
-cat <<EOF > c_head2
-#include <stdio.h>
-#include <notmuch.h>
-#include <notmuch-test.h>
-int main (int argc, char** argv)
-{
-   notmuch_database_t *db;
-   notmuch_status_t stat;
-   char *msg = NULL;
-   notmuch_message_t *message = NULL;
-   const char *id = "1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
-
-   stat = notmuch_database_open_verbose (argv[1], NOTMUCH_DATABASE_MODE_READ_WRITE, &db, &msg);
-   if (stat != NOTMUCH_STATUS_SUCCESS) {
-     fprintf (stderr, "error opening database: %d %s\n", stat, msg ? msg : "");
-     exit (1);
-   }
-   EXPECT0(notmuch_database_find_message (db, id, &message));
-   EXPECT0(notmuch_database_close (db));
-EOF
-
-test_begin_subtest "Handle getting message-id from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        const char *id2;
-        id2=notmuch_message_get_message_id (message);
-        printf("%d\n%d\n", message != NULL, id2==NULL);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle getting thread-id from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        const char *id2;
-        id2=notmuch_message_get_thread_id (message);
-        printf("%d\n%d\n", message != NULL, id2==NULL);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle getting header from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        const char *from;
-        from=notmuch_message_get_header (message, "from");
-        printf("%s\n%d\n", id, from == NULL);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-# XXX TODO: test on a message from notmuch_thread_get_toplevel_messages
-# XXX this test only tests the trivial code path
-test_begin_subtest "Handle getting replies from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_messages_t *replies;
-        replies = notmuch_message_get_replies (message);
-        printf("%d\n%d\n", message != NULL, replies==NULL);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle getting message filename from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        const char *filename;
-        filename = notmuch_message_get_filename (message);
-        printf("%d\n%d\n", message != NULL, filename == NULL);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle getting all message filenames from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_filenames_t *filenames;
-        filenames = notmuch_message_get_filenames (message);
-        printf("%d\n%d\n", message != NULL, filenames == NULL);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle getting ghost flag from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_bool_t result;
-        result = notmuch_message_get_flag (message, NOTMUCH_MESSAGE_FLAG_GHOST);
-        printf("%d\n%d\n", message != NULL, result == FALSE);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle getting date from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        time_t result;
-        result = notmuch_message_get_date (message);
-        printf("%d\n%d\n", message != NULL, result == 0);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle getting tags from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_tags_t *result;
-        result = notmuch_message_get_tags (message);
-        printf("%d\n%d\n", message != NULL, result == NULL);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle counting files from closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        int result;
-        result = notmuch_message_count_files (message);
-        printf("%d\n%d\n", message != NULL, result < 0);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle adding tag with closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_status_t status;
-        status = notmuch_message_add_tag (message, "boom");
-        printf("%d\n%d\n", message != NULL, status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle removing tag with closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_status_t status;
-        status = notmuch_message_remove_tag (message, "boom");
-        printf("%d\n%d\n", message != NULL, status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle read maildir flag with closed database"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_bool_t is_set = -1;
-        is_set = notmuch_message_has_maildir_flag (message, 'S');
-        printf("%d\n%d\n", message != NULL, is_set == FALSE || is_set == TRUE);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle checking maildir flag with closed db (new API)"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_status_t status;
-        notmuch_bool_t out;
-        status = notmuch_message_has_maildir_flag_st (message, 'S', &out);
-        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle converting maildir flags to tags with closed db"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_status_t status;
-        status = notmuch_message_maildir_flags_to_tags (message);
-        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle removing all tags with closed db"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_status_t status;
-        status = notmuch_message_remove_all_tags (message);
-        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle freezing message with closed db"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_status_t status;
-        status = notmuch_message_freeze (message);
-        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_SUCCESS);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle thawing message with closed db"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_status_t status;
-        status = notmuch_message_thaw (message);
-        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_UNBALANCED_FREEZE_THAW);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle destroying message with closed db"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_message_destroy (message);
-        printf("%d\n%d\n", message != NULL,  1);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle retrieving closed db from message"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_database_t *db2;
-        db2 = notmuch_message_get_database (message);
-        printf("%d\n%d\n", message != NULL,  db == db2);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
-test_begin_subtest "Handle reindexing message with closed db"
-cat c_head2 - c_tail <<'EOF' | test_C ${MAIL_DIR}
-    {
-        notmuch_status_t status;
-        status = notmuch_message_reindex (message, NULL);
-        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
-    }
-EOF
-cat <<EOF > EXPECTED
-== stdout ==
-1
-1
-== stderr ==
-EOF
-test_expect_equal_file EXPECTED OUTPUT
-
 test_done
diff --git a/test/T566-lib-message.sh b/test/T566-lib-message.sh
new file mode 100755
index 00000000..0c5575a9
--- /dev/null
+++ b/test/T566-lib-message.sh
@@ -0,0 +1,380 @@
+#!/usr/bin/env bash
+test_description="API tests for notmuch_message_*"
+
+. $(dirname "$0")/test-lib.sh || exit 1
+
+add_email_corpus
+
+test_begin_subtest "building database"
+test_expect_success "NOTMUCH_NEW"
+
+cat <<'EOF' > c_tail
+   if (stat) {
+       const char *stat_str = notmuch_database_status_string (db);
+       if (stat_str)
+           fputs (stat_str, stderr);
+    }
+
+}
+EOF
+
+cat <<EOF > c_head
+#include <stdio.h>
+#include <notmuch.h>
+#include <notmuch-test.h>
+int main (int argc, char** argv)
+{
+   notmuch_database_t *db;
+   notmuch_status_t stat;
+   char *msg = NULL;
+   notmuch_message_t *message = NULL;
+   const char *id = "1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+
+   stat = notmuch_database_open_verbose (argv[1], NOTMUCH_DATABASE_MODE_READ_WRITE, &db, &msg);
+   if (stat != NOTMUCH_STATUS_SUCCESS) {
+     fprintf (stderr, "error opening database: %d %s\n", stat, msg ? msg : "");
+     exit (1);
+   }
+   EXPECT0(notmuch_database_find_message (db, id, &message));
+   EXPECT0(notmuch_database_close (db));
+EOF
+
+test_begin_subtest "Handle getting message-id from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        const char *id2;
+        id2=notmuch_message_get_message_id (message);
+        printf("%d\n%d\n", message != NULL, id2==NULL);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle getting thread-id from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        const char *id2;
+        id2=notmuch_message_get_thread_id (message);
+        printf("%d\n%d\n", message != NULL, id2==NULL);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle getting header from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        const char *from;
+        from=notmuch_message_get_header (message, "from");
+        printf("%s\n%d\n", id, from == NULL);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+# XXX TODO: test on a message from notmuch_thread_get_toplevel_messages
+# XXX this test only tests the trivial code path
+test_begin_subtest "Handle getting replies from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_messages_t *replies;
+        replies = notmuch_message_get_replies (message);
+        printf("%d\n%d\n", message != NULL, replies==NULL);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle getting message filename from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        const char *filename;
+        filename = notmuch_message_get_filename (message);
+        printf("%d\n%d\n", message != NULL, filename == NULL);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle getting all message filenames from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_filenames_t *filenames;
+        filenames = notmuch_message_get_filenames (message);
+        printf("%d\n%d\n", message != NULL, filenames == NULL);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle getting ghost flag from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_bool_t result;
+        result = notmuch_message_get_flag (message, NOTMUCH_MESSAGE_FLAG_GHOST);
+        printf("%d\n%d\n", message != NULL, result == FALSE);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle getting date from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        time_t result;
+        result = notmuch_message_get_date (message);
+        printf("%d\n%d\n", message != NULL, result == 0);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle getting tags from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_tags_t *result;
+        result = notmuch_message_get_tags (message);
+        printf("%d\n%d\n", message != NULL, result == NULL);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle counting files from closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        int result;
+        result = notmuch_message_count_files (message);
+        printf("%d\n%d\n", message != NULL, result < 0);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle adding tag with closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_status_t status;
+        status = notmuch_message_add_tag (message, "boom");
+        printf("%d\n%d\n", message != NULL, status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle removing tag with closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_status_t status;
+        status = notmuch_message_remove_tag (message, "boom");
+        printf("%d\n%d\n", message != NULL, status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle read maildir flag with closed database"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_bool_t is_set = -1;
+        is_set = notmuch_message_has_maildir_flag (message, 'S');
+        printf("%d\n%d\n", message != NULL, is_set == FALSE || is_set == TRUE);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle checking maildir flag with closed db (new API)"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_status_t status;
+        notmuch_bool_t out;
+        status = notmuch_message_has_maildir_flag_st (message, 'S', &out);
+        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle converting maildir flags to tags with closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_status_t status;
+        status = notmuch_message_maildir_flags_to_tags (message);
+        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle removing all tags with closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_status_t status;
+        status = notmuch_message_remove_all_tags (message);
+        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle freezing message with closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_status_t status;
+        status = notmuch_message_freeze (message);
+        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_SUCCESS);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle thawing message with closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_status_t status;
+        status = notmuch_message_thaw (message);
+        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_UNBALANCED_FREEZE_THAW);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle destroying message with closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_message_destroy (message);
+        printf("%d\n%d\n", message != NULL,  1);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle retrieving closed db from message"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_database_t *db2;
+        db2 = notmuch_message_get_database (message);
+        printf("%d\n%d\n", message != NULL,  db == db2);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "Handle reindexing message with closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_status_t status;
+        status = notmuch_message_reindex (message, NULL);
+        printf("%d\n%d\n", message != NULL,  status == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* [PATCH 02/10] test: add regression test for n_q_{create,_get_query_string}
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
  2020-07-22 10:51 ` [PATCH 01/10] test: move notmuch_message_* tests to their own file David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-22 10:51 ` [PATCH 03/10] test: regression test for notmuch_query_get_database David Bremner
                   ` (8 subsequent siblings)
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

Start a new file of tests, to keep to the (emerging) scheme of one
notmuch_foo group per file
---
 test/T564-lib-query.sh | 61 ++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 61 insertions(+)
 create mode 100755 test/T564-lib-query.sh

diff --git a/test/T564-lib-query.sh b/test/T564-lib-query.sh
new file mode 100755
index 00000000..103870a6
--- /dev/null
+++ b/test/T564-lib-query.sh
@@ -0,0 +1,61 @@
+#!/usr/bin/env bash
+test_description="notmuch_database_* API"
+
+. $(dirname "$0")/test-lib.sh || exit 1
+
+add_email_corpus
+
+test_begin_subtest "building database"
+test_expect_success "NOTMUCH_NEW"
+
+cat <<EOF > c_head
+#include <stdio.h>
+#include <notmuch.h>
+#include <notmuch-test.h>
+#include <talloc.h>
+int main (int argc, char** argv)
+{
+   notmuch_database_t *db;
+   notmuch_status_t stat;
+   char *msg = NULL;
+
+   stat = notmuch_database_open_verbose (argv[1], NOTMUCH_DATABASE_MODE_READ_WRITE, &db, &msg);
+   if (stat != NOTMUCH_STATUS_SUCCESS) {
+     fprintf (stderr, "error opening database: %d %s\n", stat, msg ? msg : "");
+     exit (1);
+   }
+EOF
+
+cat <<'EOF' > c_tail
+   if (stat) {
+       const char *stat_str = notmuch_database_status_string (db);
+       if (stat_str)
+           fputs (stat_str, stderr);
+    }
+
+}
+EOF
+
+test_begin_subtest "roundtrip query string with closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+        const char *ret;
+
+        EXPECT0(notmuch_database_close (db));
+        query = notmuch_query_create (db, str);
+        ret = notmuch_query_get_query_string (query);
+
+        printf("%s\n%s\n", str, ret);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
+id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* [PATCH 03/10] test: regression test for notmuch_query_get_database
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
  2020-07-22 10:51 ` [PATCH 01/10] test: move notmuch_message_* tests to their own file David Bremner
  2020-07-22 10:51 ` [PATCH 02/10] test: add regression test for n_q_{create,_get_query_string} David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-22 10:51 ` [PATCH 04/10] test: regression test for set_omit_excluded David Bremner
                   ` (7 subsequent siblings)
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

Current functionality is too trivial to really justify a test, but
it's simpler just to test the complete API.
---
 test/T564-lib-query.sh | 23 ++++++++++++++++++++++-
 1 file changed, 22 insertions(+), 1 deletion(-)

diff --git a/test/T564-lib-query.sh b/test/T564-lib-query.sh
index 103870a6..ac08344f 100755
--- a/test/T564-lib-query.sh
+++ b/test/T564-lib-query.sh
@@ -1,5 +1,5 @@
 #!/usr/bin/env bash
-test_description="notmuch_database_* API"
+test_description="notmuch_query_* API"
 
 . $(dirname "$0")/test-lib.sh || exit 1
 
@@ -58,4 +58,25 @@ id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
 EOF
 test_expect_equal_file EXPECTED OUTPUT
 
+test_begin_subtest "retrieve closed db from query"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+        notmuch_database_t *db2;
+
+        query = notmuch_query_create (db, str);
+        EXPECT0(notmuch_database_close (db));
+        db2 = notmuch_query_get_database (query);
+
+        printf("%d\n", db == db2);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
 test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* [PATCH 04/10] test: regression test for set_omit_excluded
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
                   ` (2 preceding siblings ...)
  2020-07-22 10:51 ` [PATCH 03/10] test: regression test for notmuch_query_get_database David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-22 10:51 ` [PATCH 05/10] test: regression test for n_q_{set, get}_sort David Bremner
                   ` (6 subsequent siblings)
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

---
 test/T564-lib-query.sh | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

diff --git a/test/T564-lib-query.sh b/test/T564-lib-query.sh
index ac08344f..ea176191 100755
--- a/test/T564-lib-query.sh
+++ b/test/T564-lib-query.sh
@@ -79,4 +79,24 @@ cat <<EOF > EXPECTED
 EOF
 test_expect_equal_file EXPECTED OUTPUT
 
+test_begin_subtest "set omit_excluded on closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+
+        query = notmuch_query_create (db, str);
+        EXPECT0(notmuch_database_close (db));
+        notmuch_query_set_omit_excluded (query, NOTMUCH_EXCLUDE_ALL);
+
+        printf("SUCCESS\n");
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+SUCCESS
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
 test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* [PATCH 05/10] test: regression test for n_q_{set, get}_sort
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
                   ` (3 preceding siblings ...)
  2020-07-22 10:51 ` [PATCH 04/10] test: regression test for set_omit_excluded David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-22 10:51 ` [PATCH 06/10] test: add regression test for n_q_add_tag_exclude David Bremner
                   ` (5 subsequent siblings)
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

We just want to make sure accessing the query owned by a closed db
does not cause a crash.
---
 test/T564-lib-query.sh | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

diff --git a/test/T564-lib-query.sh b/test/T564-lib-query.sh
index ea176191..14e47cfb 100755
--- a/test/T564-lib-query.sh
+++ b/test/T564-lib-query.sh
@@ -99,4 +99,25 @@ SUCCESS
 EOF
 test_expect_equal_file EXPECTED OUTPUT
 
+test_begin_subtest "roundtrip sort on closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+        notmuch_sort_t sort;
+
+        query = notmuch_query_create (db, str);
+        EXPECT0(notmuch_database_close (db));
+        notmuch_query_set_sort (query, NOTMUCH_SORT_UNSORTED);
+        sort = notmuch_query_get_sort (query);
+        printf("%d\n", sort == NOTMUCH_SORT_UNSORTED);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
 test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* [PATCH 06/10] test: add regression test for n_q_add_tag_exclude
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
                   ` (4 preceding siblings ...)
  2020-07-22 10:51 ` [PATCH 05/10] test: regression test for n_q_{set, get}_sort David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-22 10:51 ` [PATCH 07/10] test: regression test for n_q_search_threads David Bremner
                   ` (4 subsequent siblings)
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

This relies on the change to not tear down the auxilary Xapian
objects, in particular the query parser, when the database is closed.
---
 test/T564-lib-query.sh | 19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

diff --git a/test/T564-lib-query.sh b/test/T564-lib-query.sh
index 14e47cfb..a2f5d731 100755
--- a/test/T564-lib-query.sh
+++ b/test/T564-lib-query.sh
@@ -120,4 +120,23 @@ cat <<EOF > EXPECTED
 EOF
 test_expect_equal_file EXPECTED OUTPUT
 
+test_begin_subtest "add tag_exclude on closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+
+        query = notmuch_query_create (db, str);
+        EXPECT0(notmuch_database_close (db));
+        stat = notmuch_query_add_tag_exclude (query, "spam");
+        printf("%d\n", stat == NOTMUCH_STATUS_SUCCESS);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
 test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* [PATCH 07/10] test: regression test for n_q_search_threads
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
                   ` (5 preceding siblings ...)
  2020-07-22 10:51 ` [PATCH 06/10] test: add regression test for n_q_add_tag_exclude David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-22 10:51 ` [PATCH 08/10] test: regression test for n_q_search_messages David Bremner
                   ` (3 subsequent siblings)
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

At least this exception is caught.
---
 test/T564-lib-query.sh | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

diff --git a/test/T564-lib-query.sh b/test/T564-lib-query.sh
index a2f5d731..97729f9a 100755
--- a/test/T564-lib-query.sh
+++ b/test/T564-lib-query.sh
@@ -139,4 +139,27 @@ cat <<EOF > EXPECTED
 EOF
 test_expect_equal_file EXPECTED OUTPUT
 
+test_begin_subtest "search threads on closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+        notmuch_threads_t *threads;
+
+        query = notmuch_query_create (db, str);
+        EXPECT0(notmuch_database_close (db));
+        stat = notmuch_query_search_threads (query, &threads);
+
+        printf("%d\n", stat == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+== stderr ==
+A Xapian exception occurred performing query: Database has been closed
+Query string was: id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
 test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* [PATCH 08/10] test: regression test for n_q_search_messages
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
                   ` (6 preceding siblings ...)
  2020-07-22 10:51 ` [PATCH 07/10] test: regression test for n_q_search_threads David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-22 10:51 ` [PATCH 09/10] test: regression tests for n_q_count_{messages, threads} David Bremner
                   ` (2 subsequent siblings)
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

Exception handling matches notmuch_query_search_threads, at least for
this case.
---
 test/T564-lib-query.sh | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

diff --git a/test/T564-lib-query.sh b/test/T564-lib-query.sh
index 97729f9a..dda32be7 100755
--- a/test/T564-lib-query.sh
+++ b/test/T564-lib-query.sh
@@ -162,4 +162,27 @@ Query string was: id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
 EOF
 test_expect_equal_file EXPECTED OUTPUT
 
+test_begin_subtest "search messages on closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+        notmuch_messages_t *messages;
+
+        query = notmuch_query_create (db, str);
+        EXPECT0(notmuch_database_close (db));
+        stat = notmuch_query_search_messages (query, &messages);
+
+        printf("%d\n", stat == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+== stderr ==
+A Xapian exception occurred performing query: Database has been closed
+Query string was: id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
 test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* [PATCH 09/10] test: regression tests for n_q_count_{messages, threads}
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
                   ` (7 preceding siblings ...)
  2020-07-22 10:51 ` [PATCH 08/10] test: regression test for n_q_search_messages David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-22 10:51 ` [PATCH 10/10] test: regression test for notmuch_query_destroy David Bremner
  2020-07-29 15:47 ` batch 8, API cleanup for exception handling David Bremner
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

At least these exceptions are caught.
---
 test/T564-lib-query.sh | 46 ++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 46 insertions(+)

diff --git a/test/T564-lib-query.sh b/test/T564-lib-query.sh
index dda32be7..745d28a4 100755
--- a/test/T564-lib-query.sh
+++ b/test/T564-lib-query.sh
@@ -185,4 +185,50 @@ Query string was: id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
 EOF
 test_expect_equal_file EXPECTED OUTPUT
 
+test_begin_subtest "count messages on closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+        unsigned int count;
+
+        query = notmuch_query_create (db, str);
+        EXPECT0(notmuch_database_close (db));
+        stat = notmuch_query_count_messages (query, &count);
+
+        printf("%d\n", stat == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+== stderr ==
+A Xapian exception occurred performing query: Database has been closed
+Query string was: id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_begin_subtest "count threads on closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+        unsigned int count;
+
+        query = notmuch_query_create (db, str);
+        EXPECT0(notmuch_database_close (db));
+        stat = notmuch_query_count_threads (query, &count);
+
+        printf("%d\n", stat == NOTMUCH_STATUS_XAPIAN_EXCEPTION);
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+== stderr ==
+A Xapian exception occurred performing query: Database has been closed
+Query string was: id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
 test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* [PATCH 10/10] test: regression test for notmuch_query_destroy
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
                   ` (8 preceding siblings ...)
  2020-07-22 10:51 ` [PATCH 09/10] test: regression tests for n_q_count_{messages, threads} David Bremner
@ 2020-07-22 10:51 ` David Bremner
  2020-07-29 15:47 ` batch 8, API cleanup for exception handling David Bremner
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-22 10:51 UTC (permalink / raw)
  To: notmuch; +Cc: David Bremner

As with other void API entries, not crashing counts as success.
---
 test/T564-lib-query.sh | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

diff --git a/test/T564-lib-query.sh b/test/T564-lib-query.sh
index 745d28a4..50b0a88e 100755
--- a/test/T564-lib-query.sh
+++ b/test/T564-lib-query.sh
@@ -231,4 +231,24 @@ Query string was: id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net
 EOF
 test_expect_equal_file EXPECTED OUTPUT
 
+test_begin_subtest "destroy query with closed db"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+    {
+        notmuch_query_t *query;
+        const char *str = "id:1258471718-6781-1-git-send-email-dottedmag@dottedmag.net";
+
+        query = notmuch_query_create (db, str);
+        EXPECT0(notmuch_database_close (db));
+        notmuch_query_destroy (query);
+
+        printf("SUCCESS\n");
+    }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+SUCCESS
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
 test_done
-- 
2.27.0

^ permalink raw reply related	[flat|nested] 12+ messages in thread

* Re: batch 8, API cleanup for exception handling
  2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
                   ` (9 preceding siblings ...)
  2020-07-22 10:51 ` [PATCH 10/10] test: regression test for notmuch_query_destroy David Bremner
@ 2020-07-29 15:47 ` David Bremner
  10 siblings, 0 replies; 12+ messages in thread
From: David Bremner @ 2020-07-29 15:47 UTC (permalink / raw)
  To: notmuch

David Bremner <david@tethera.net> writes:

> Apparently no changes are needed to notmuch_query_* to handle exceptions from closed databases.
>
> This most likely needs to be applied on top of
>
>      id:20200719131857.158655-1-david@tethera.net
>
> It certainly needs the changes from
>
>    id:20200714224119.717845-1-david@tethera.net, which are not in master yet.

applied this batch (tests only) to master

d

^ permalink raw reply	[flat|nested] 12+ messages in thread

end of thread, other threads:[~2020-07-29 15:47 UTC | newest]

Thread overview: 12+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2020-07-22 10:51 batch 8, API cleanup for exception handling David Bremner
2020-07-22 10:51 ` [PATCH 01/10] test: move notmuch_message_* tests to their own file David Bremner
2020-07-22 10:51 ` [PATCH 02/10] test: add regression test for n_q_{create,_get_query_string} David Bremner
2020-07-22 10:51 ` [PATCH 03/10] test: regression test for notmuch_query_get_database David Bremner
2020-07-22 10:51 ` [PATCH 04/10] test: regression test for set_omit_excluded David Bremner
2020-07-22 10:51 ` [PATCH 05/10] test: regression test for n_q_{set, get}_sort David Bremner
2020-07-22 10:51 ` [PATCH 06/10] test: add regression test for n_q_add_tag_exclude David Bremner
2020-07-22 10:51 ` [PATCH 07/10] test: regression test for n_q_search_threads David Bremner
2020-07-22 10:51 ` [PATCH 08/10] test: regression test for n_q_search_messages David Bremner
2020-07-22 10:51 ` [PATCH 09/10] test: regression tests for n_q_count_{messages, threads} David Bremner
2020-07-22 10:51 ` [PATCH 10/10] test: regression test for notmuch_query_destroy David Bremner
2020-07-29 15:47 ` batch 8, API cleanup for exception handling David Bremner

Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).